//+------------------------------------------------------------------+
//

#property copyright "Ruben Couto - Rain Forex"
#property link      "http://www.rainforex.com"

#include <stderror.mqh> 
//+------------------------------------------------------------------+
//| Global Variables / Includes                                      |
//+------------------------------------------------------------------+
datetime      CurrTime = 0;
datetime      PrevTime = 0;
  string           Sym = "";
  string     ADX_Trend = "";
  string     Std_Dev_T = "";
  string      Tradable = "";
  string TradableHours ="";
  string         Trade = "";
     int     TimeFrame = 0;
     int         Shift = 0;
     int     SymDigits = 5;
  double     SymPoints = 0.0001;
  double           Aux = 0;
     int     OpenTPair = 0;
  double StopLossLevel, TakeProfitLevel;
     int BarCount;
     int j;
     int TodaysSeconds;
     int Periods = 16;
  double Lots = 0.01;
     int MagicNumber = 0001;
  double IncrementTrend = 4;           //For Wide_EMA, STdDv e ADX
     int BuyTriger = 0;
     int SellTriger = 0;
  double Indice_RS_0_1 = 0.4;         //Margem entre R1 e S1, para no abrir trades
  double Indice_RS_0_1_1 = 0.07;        //Margem entre R0_1-R1 e S0_1-S1, para mudar de direco... (percentagem do intervalo entre R1-R2 e S1-S2)
     int Instrument_b;                 //Limite para os instrumentos, em funo de LimitMaxOpenPos
  double AverageOpenLots;              //Average Lots of open orders
  double PercentTrend;                 //Percentage Trend - SMA_Trend...
  
         
int      fontsize = 8, shift = 0, i;
double   P, S1, S0_1, S0_1_1, R1, R0_1, R0_1_1, S2, R2, S3, R3;



//+------------------------------------------------------------------+
//| Expert User Inputs                                               |
//+------------------------------------------------------------------+
extern    bool UseCompletedBars = true;
extern    bool     EachTickMode = false;
extern    bool            Hedge = true;
extern    bool    UseTakeProfit = true;
extern     int     ProfitTarget = 15; 
extern    bool      UseStopLoss = true;
extern     int         StopLoss = 60; 
extern    bool  UseTrailingStop = true;
extern     int     TrailingStop = 10;
extern     int         Slippage = 5;
extern     int     MaxOpenTPair = 2;
extern  double     SinalDecisao = 75.00;
extern  double    Sinalparasair = 75.00;
extern     int    PercentToRisk = 2;            //1-100
extern  double    Hours2Analize = 1;            //Intervalo para reanalisar o TS e para fechar ordens com lucro
extern     int      Instruments = 6;
extern  string      Limitations = "No";         //Number of open trades and/or Max Lots
extern     int  LimitMaxOpenPos = 5;            // If Limitations is "Yes"
extern     int      LimitMaxLot = 1;            // If Limitations is "Yes"
extern     int       TrendLimit = 75;          // Limite a partir do qual inverte novamente os sinais


extern color colorPivot = DeepSkyBlue;
extern color colorRes1 = Lime;
extern color colorRes0_1 = Yellow;
extern color colorRes0_1_1 = White;
extern color colorRes2 = Orange;
extern color colorRes3 = Chocolate;
extern color colorSup1 = Lime;
extern color colorSup0_1 = Yellow;
extern color colorSup0_1_1 = White;
extern color colorSup2 = Orange;
extern color colorSup3 = Chocolate;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
         Sym = Symbol();
   TimeFrame = Period();   
   SymPoints = MarketInfo( Sym, MODE_POINT  );
   SymDigits = MarketInfo( Sym, MODE_DIGITS );
   
   if (Limitations == "Yes") {
      MaxOpenTPair = LimitMaxOpenPos;
      Instrument_b = Instruments;
      ProfitTarget = 20;
      if (Instruments > LimitMaxOpenPos) Instrument_b = LimitMaxOpenPos;
      }
   

   

   
   //Print ("SymPoints Before: ",SymPoints);
   
   //---

        if( SymPoints == 0.1     ) { SymPoints = 1;       SymDigits = 1; }
        if( SymPoints == 0.01    ) { SymPoints = 0.01;     SymDigits = 2; }
        if( SymPoints == 0.001   ) { SymPoints = 0.01;    SymDigits = 3; }
        if( SymPoints == 0.0001  ) { SymPoints = 0.0001;   SymDigits = 4; }
        if( SymPoints == 0.00001 ) { SymPoints = 0.0001;  SymDigits = 5; }
        if( SymPoints == 0       ) { SymPoints = 0.0001;  SymDigits = 5; }
  
  //Print ("SymPoints After: ",SymPoints);
  
  
  /*
  
     
   //EURUSD - 1M - Tested
   if (Sym == "EURUSD" || Sym == "EURUSDX" || Sym == "EURUSDmicro") {
         ProfitTarget = ProfitTarget*1; 
         Periods = Periods;
         SinalDecisao = SinalDecisao;
         }   
   
 
   
   //GBPUSD - 15M ???
   if (Sym == "GBPUSD" || Sym == "GBPUSDX" || Sym == "GBPUSDmicro") {
         ProfitTarget = ProfitTarget*0.60; 
         Periods = Periods;
         SinalDecisao = SinalDecisao + 15;
            if (SinalDecisao >= 100) SinalDecisao = 99;
         }
   
   //AUDUSD - 4H ???
   if (Sym == "AUDUSD" || Sym == "AUDUSDX" || Sym == "AUDUSDmicro") {
         ProfitTarget = ProfitTarget; 
         Periods = Periods;
         SinalDecisao = SinalDecisao;
         }

   //USDJPY - 15M - Tested
   if (Sym == "USDJPY" || Sym == "USDJPYX" || Sym == "USDJPYmicro") {
         ProfitTarget = ProfitTarget; 
         Periods = Periods;
         SinalDecisao = SinalDecisao;
            if (SinalDecisao >= 100) SinalDecisao = 99;
         }

   //USDCHF - 4H ???
   if (Sym == "USDCHF" || Sym == "USDCHFX" || Sym == "USDCHFmicro") {
         ProfitTarget = ProfitTarget*1.50; 
         Periods = Periods*1.5;
         SinalDecisao = SinalDecisao + 10;
            if (SinalDecisao >= 100) SinalDecisao = 99;
         }   

   //NZDUSD - M5 ???
   if (Sym == "NZDUSD" || Sym == "NZDUSDX" || Sym == "NZDUSDmicro") {
         ProfitTarget = ProfitTarget*1.20; 
         Periods = Periods;
         SinalDecisao = SinalDecisao;
         } 


  */
  

  
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() { return(0); }

//+------------------------------------------------------------------+
//| Expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{    
     int RealTime = 0;
   
     
     
      //Correct TP = 0.0 and SL = 0.0 - BUY
         for (int correct = 0; correct <= OrdersTotal()+1; correct++) {
         OrderSelect(correct, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_BUY && (OrderStopLoss()==0.0 || OrderTakeProfit()==0.0))
            {OrderModify(OrderTicket(), OrderOpenPrice(), Bid - SymPoints * StopLoss, OrderOpenPrice() + SymPoints * ProfitTarget, 0, Yellow);
             if (!EachTickMode) BarCount = Bars;
             continue;
             }
            }


      //Correct TP = 0.0 and SL = 0.0 - SELL
         for (int correct2 = 0; correct2 <= OrdersTotal()+1; correct2++) {
         OrderSelect(correct2, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_SELL && (OrderStopLoss()==0.0 || OrderTakeProfit()==0.0))
            {OrderModify(OrderTicket(), OrderOpenPrice(), Ask + SymPoints * StopLoss, OrderOpenPrice() - SymPoints * ProfitTarget, 0, Yellow);
             if (!EachTickMode) BarCount = Bars;
             continue;
             }
            }

     
     
     //Trailing stop - BUY
      for (int x = 0; x <= OrdersTotal()+1; x++) {
      
         OrderSelect(x, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_BUY)
            {
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > SymPoints * TrailingStop) {
                  if((OrderStopLoss() < Bid - SymPoints * TrailingStop) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - (SymPoints * TrailingStop), OrderTakeProfit(), 0, Yellow);
                     if (!EachTickMode) BarCount = Bars;
                     }
                  }
               }
            }
         }
      
      
      //Trailing stop - SELL
      for (int y = 0; y <= OrdersTotal()+1; y++) {
      
         OrderSelect(y, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_SELL)
            {
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (SymPoints * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + SymPoints * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + (SymPoints * TrailingStop), OrderTakeProfit(), 0, Yellow);
                     if (!EachTickMode) BarCount = Bars;
                     }
                  }
               }
            }
         }      
      
      
      //---- Need to chek for a new Signal?

      
       
     // CURRENT
      
                           
         //---- Indicador Exponential Moving Average - TREND - M15 
         double EMA_0 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 0);
         double EMA_1 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 1);
         
         //---- Indicador Wide Exponential Moving Average - TREND - M15
         double Wide_EMA_0 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 0);
         double Wide_EMA_1 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 1);
         
         //---- Indicador Simple Moving Average - TREND - M15
         double SMA_0 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 0);
         double SMA_1 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 1);
         
         //---- Indicador MACD - TREND - M15
         double MACD_Main_0 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_MAIN, RealTime + 0);
         double MACD_Signal_0 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_SIGNAL, RealTime + 0);
         
         //---- Indicador ADX (+D e -D) - TREND - M15
         double ADX_Plus = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_PLUSDI, RealTime + 0);
         double ADX_Minus = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_MINUSDI, RealTime + 0);
         
         //---- Indicador StdDev - TREND - M15
         double StdDev_0 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 0);
         double StdDev_1 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 1);
         
         //---- Indicador Parabolic SAR - TREND - M15
         double SAR_0 = iSAR(NULL, NULL, 0.02, 0.2, RealTime + 0);
         
         //---- Indicador Stochastic - OSCILLATOR - M15
         double Stoch_0 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 0);
         double Stoch_1 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 1);





    
     // CURRENT - 1
      
                           
         //---- Indicador Exponential Moving Average - TREND - M15 
         double EMA_0_1 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 1);
         double EMA_1_1 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 2);
         
         //---- Indicador Wide Exponential Moving Average - TREND - M15
         double Wide_EMA_0_1 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 1);
         double Wide_EMA_1_1 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 2);
         
         //---- Indicador Simple Moving Average - TREND - M15
         double SMA_0_1 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 1);
         double SMA_1_1 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 2);
         
         //---- Indicador MACD - TREND - M15
         double MACD_Main_0_1 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_MAIN, RealTime + 1);
         double MACD_Signal_0_1 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_SIGNAL, RealTime + 1);
         
         //---- Indicador ADX (+D e -D) - TREND - M15
         double ADX_Plus_1 = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_PLUSDI, RealTime + 1);
         double ADX_Minus_1 = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_MINUSDI, RealTime + 1);
         
         //---- Indicador StdDev - TREND - M15
         double StdDev_0_1 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 1);
         double StdDev_1_1 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 2);
         
         //---- Indicador Parabolic SAR - TREND - M15
         double SAR_0_1 = iSAR(NULL, NULL, 0.02, 0.2, RealTime + 1);
         
         //---- Indicador Stochastic - OSCILLATOR - M15
         double Stoch_0_1 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 1);
         double Stoch_1_1 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 2);





  



     // CURRENT - 2
      
                           
         //---- Indicador Exponential Moving Average - TREND - M15 
         double EMA_0_2 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 2);
         double EMA_1_2 = iMA(NULL, NULL, Periods, 0, MODE_EMA, PRICE_CLOSE, RealTime + 3);
         
         //---- Indicador Wide Exponential Moving Average - TREND - M15
         double Wide_EMA_0_2 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 2);
         double Wide_EMA_1_2 = iMA(NULL, NULL, Periods*IncrementTrend, 0, MODE_EMA, PRICE_CLOSE, RealTime + 3);
         
         //---- Indicador Simple Moving Average - TREND - M15
         double SMA_0_2 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 2);
         double SMA_1_2 = iMA(NULL, NULL, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 3);
         
         //---- Indicador MACD - TREND - M15
         double MACD_Main_0_2 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_MAIN, RealTime + 2);
         double MACD_Signal_0_2 = iMACD(NULL,NULL,12,26,9,PRICE_CLOSE, MODE_SIGNAL, RealTime + 2);
         
         //---- Indicador ADX (+D e -D) - TREND - M15
         double ADX_Plus_2 = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_PLUSDI, RealTime + 2);
         double ADX_Minus_2 = iADX(NULL, NULL, Periods, PRICE_CLOSE, MODE_MINUSDI, RealTime + 2);
         
         //---- Indicador StdDev - TREND - M15
         double StdDev_0_2 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 2);
         double StdDev_1_2 = iStdDev(NULL, NULL, Periods, MODE_SMA, 0, PRICE_CLOSE, RealTime + 3);
         
         //---- Indicador Parabolic SAR - TREND - M15
         double SAR_0_2 = iSAR(NULL, NULL, 0.02, 0.2, RealTime + 2);
         
         //---- Indicador Stochastic - OSCILLATOR - M15
         double Stoch_0_2 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 2);
         double Stoch_1_2 = iStochastic(NULL, NULL, 5, 3, 3, MODE_SMA, 0, MODE_BASE, RealTime + 3);





         
         
         
         
         //---- Construo do Sinal
         
       double SinalCompra = 0;
       double  SinalVende = 0;
       
       double SinalCompra_1 = 0;
       double  SinalVende_1 = 0;
       
       double SinalCompra_2 = 0;
       double  SinalVende_2 = 0;
       
       
       
   

         
         
         
         
         //CURRENT
         
       
         
         if (EMA_0 > EMA_1) {SinalCompra = SinalCompra+2;}
         if (EMA_0 < EMA_1) {SinalVende = SinalVende+2;}
         
         if (SMA_0 > SMA_1) {SinalCompra = SinalCompra+1;}
         if (SMA_0 < SMA_1) {SinalVende = SinalVende+1;}
         
         if (EMA_0 > SMA_0) {SinalCompra = SinalCompra+3;}
         if (EMA_0 < SMA_0) {SinalVende = SinalVende+3;}
         
         if (Wide_EMA_0 > Wide_EMA_1) {SinalCompra = SinalCompra+4;}
         if (Wide_EMA_0 < Wide_EMA_1) {SinalVende = SinalVende+4;}
         
         if (MACD_Main_0 > MACD_Signal_0) {SinalCompra = SinalCompra+2;}
         if (MACD_Main_0 < MACD_Signal_0) {SinalVende = SinalVende+2;}
         
         if (ADX_Plus > ADX_Minus) {SinalCompra = SinalCompra+2;}
         if (ADX_Plus < ADX_Minus) {SinalVende = SinalVende+2;}
         
         if (StdDev_0 > StdDev_1) {SinalCompra = SinalCompra+1; SinalVende = SinalVende+3;}
         
         if (SAR_0 < iClose(NULL,NULL,0)) {SinalCompra = SinalCompra+2;}
         if (SAR_0 > iClose(NULL,NULL,0)) {SinalVende = SinalVende+2;}
         
         if (Stoch_0 > Stoch_1) {SinalCompra = SinalCompra+1;}
         if (Stoch_0 < Stoch_1) {SinalVende = SinalVende+1;}
         




         
         
         //CURRENT - 1
         
       
         
         if (EMA_0_1 > EMA_1_1) {SinalCompra_1 = SinalCompra_1+2;}
         if (EMA_0_1 < EMA_1_1) {SinalVende_1 = SinalVende_1+2;}
         
         if (SMA_0_1 > SMA_1_1) {SinalCompra_1 = SinalCompra_1+1;}
         if (SMA_0_1 < SMA_1_1) {SinalVende_1 = SinalVende_1+1;}
         
         if (EMA_0_1 > SMA_0_1) {SinalCompra_1 = SinalCompra_1+3;}
         if (EMA_0_1 < SMA_0_1) {SinalVende_1 = SinalVende_1+3;}
         
         if (Wide_EMA_0_1 > Wide_EMA_1_1) {SinalCompra_1 = SinalCompra_1+4;}
         if (Wide_EMA_0_1 < Wide_EMA_1_1) {SinalVende_1 = SinalVende_1+4;}
         
         if (MACD_Main_0_1 > MACD_Signal_0_1) {SinalCompra_1 = SinalCompra_1+2;}
         if (MACD_Main_0_1 < MACD_Signal_0_1) {SinalVende_1 = SinalVende_1+2;}
         
         if (ADX_Plus_1 > ADX_Minus_1) {SinalCompra_1 = SinalCompra_1+2;}
         if (ADX_Plus_1 < ADX_Minus_1) {SinalVende_1 = SinalVende_1+2;}
         
         if (StdDev_0_1 > StdDev_1_1) {SinalCompra_1 = SinalCompra_1+1; SinalVende_1 = SinalVende_1+3;}
         
         if (SAR_0_1 < iClose(NULL,NULL,0)) {SinalCompra_1 = SinalCompra_1+2;}
         if (SAR_0_1 > iClose(NULL,NULL,0)) {SinalVende_1 = SinalVende_1+2;}
         
         if (Stoch_0_1 > Stoch_1_1) {SinalCompra_1 = SinalCompra_1+1;}
         if (Stoch_0_1 < Stoch_1_1) {SinalVende_1 = SinalVende_1+1;}
         


         
         
         //CURRENT - 2
         
       
         
         if (EMA_0_2 > EMA_1_2) {SinalCompra_2 = SinalCompra_2+2;}
         if (EMA_0_2 < EMA_1_2) {SinalVende_2 = SinalVende_2+2;}
         
         if (SMA_0_2 > SMA_1_2) {SinalCompra_2 = SinalCompra_2+1;}
         if (SMA_0_2 < SMA_1_2) {SinalVende_2 = SinalVende_2+1;}
         
         if (EMA_0_2 > SMA_0_2) {SinalCompra_2 = SinalCompra_2+3;}
         if (EMA_0_2 < SMA_0_2) {SinalVende_2 = SinalVende_2+3;}
         
         if (Wide_EMA_0_2 > Wide_EMA_1_2) {SinalCompra_2 = SinalCompra_2+4;}
         if (Wide_EMA_0_2 < Wide_EMA_1_2) {SinalVende_2 = SinalVende_2+4;}
         
         if (MACD_Main_0_2 > MACD_Signal_0_2) {SinalCompra_2 = SinalCompra_2+2;}
         if (MACD_Main_0_2 < MACD_Signal_0_2) {SinalVende_2 = SinalVende_2+2;}
         
         if (ADX_Plus_2 > ADX_Minus_2) {SinalCompra_2 = SinalCompra_2+2;}
         if (ADX_Plus_2 < ADX_Minus_2) {SinalVende_2 = SinalVende_2+2;}
         
         if (StdDev_0_2 > StdDev_1_2) {SinalCompra_2 = SinalCompra_2+1; SinalVende_2 = SinalVende_2+3;}
         
         if (SAR_0_2 < iClose(NULL,NULL,0)) {SinalCompra_2 = SinalCompra_2+2;}
         if (SAR_0_2 > iClose(NULL,NULL,0)) {SinalVende_2 = SinalVende_2+2;}
         
         if (Stoch_0_2 > Stoch_1_2) {SinalCompra_2 = SinalCompra_2+1;}
         if (Stoch_0_2 < Stoch_1_2) {SinalVende_2 = SinalVende_2+1;}
         


         
         
         
         
         
         int TotalPontos = 20;

         
         
         
         //TREND***** 
         double StdDev_0_Trend = iStdDev(NULL, NULL, Periods*IncrementTrend, MODE_SMA, 0, PRICE_CLOSE, 0);
         double StdDev_1_Trend = iStdDev(NULL, NULL, Periods*IncrementTrend, MODE_SMA, 0, PRICE_CLOSE, 1);
         
         double ADX_Plus_Prev_Trend = iADX(NULL, NULL, Periods*IncrementTrend, PRICE_CLOSE, MODE_PLUSDI, 1);
         double ADX_Minus_Prev_Trend = iADX(NULL, NULL, Periods*IncrementTrend, PRICE_CLOSE, MODE_MINUSDI, 1);
         
         double ADX_Plus_Trend = iADX(NULL, NULL, Periods*IncrementTrend, PRICE_CLOSE, MODE_PLUSDI, 0);
         double ADX_Minus_Trend = iADX(NULL, NULL, Periods*IncrementTrend, PRICE_CLOSE, MODE_MINUSDI, 0);
         
         double SMA_Trend_0 = iMA(NULL, PERIOD_H1, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime);
         double SMA_Trend_1 = iMA(NULL, PERIOD_H1, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 1);
         
         double SMA_Trend_0_Slow = iMA(NULL, PERIOD_H4, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime);
         double SMA_Trend_1_Slow = iMA(NULL, PERIOD_H4, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 1);
         
         double SMA_Trend_0_Fast = iMA(NULL, PERIOD_M15, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime);
         double SMA_Trend_1_Fast = iMA(NULL, PERIOD_M15, Periods, 0, MODE_SMA, PRICE_CLOSE, RealTime + 1);

         
         PercentTrend = NormalizeDouble((((SMA_Trend_0+SMA_Trend_0_Slow+SMA_Trend_0_Fast) - (SMA_Trend_1+SMA_Trend_1_Slow+SMA_Trend_1_Fast))*100000/(((SMA_Trend_1+SMA_Trend_1_Slow+SMA_Trend_1_Fast)/3)+0.0000000001)),2);
         
         ADX_Trend = "None";
         if (ADX_Plus_Trend > ADX_Plus_Prev_Trend) ADX_Trend = "Up";
         if (ADX_Minus_Trend > ADX_Minus_Prev_Trend) ADX_Trend = "Down";
         
         if (StdDev_0_Trend > StdDev_1_Trend) Std_Dev_T = "Trade";
         if (StdDev_0_Trend <= StdDev_1_Trend) Std_Dev_T = "No Trade";
         
         
          
         
         
         
         SinalCompra = NormalizeDouble (SinalCompra*100/TotalPontos,1);
         SinalVende = NormalizeDouble (SinalVende*100/TotalPontos,1);
         
         SinalCompra_1 = NormalizeDouble (SinalCompra_1*100/TotalPontos,1);
         SinalVende_1 = NormalizeDouble (SinalVende_1*100/TotalPontos,1);
         
         SinalCompra_2 = NormalizeDouble (SinalCompra_2*100/TotalPontos,1);
         SinalVende_2 = NormalizeDouble (SinalVende_2*100/TotalPontos,1);
         
         
         
         
         if (SinalCompra_2 <= 0) {SinalCompra_2 = 0.1;}
         if (SinalCompra_2 >= 100) {SinalCompra_2 = 99.9;}
         if (SinalVende_2 <= 0) {SinalVende_2 = 0.1;}
         if (SinalVende_2 >= 100) {SinalVende_2 = 99.9;}
         if (SinalCompra_1 <= 0) {SinalCompra_1 = 0.1;}
         if (SinalCompra_1 >= 100) {SinalCompra_1 = 99.9;}
         if (SinalVende_1 <= 0) {SinalVende_1 = 0.1;}
         if (SinalVende_1 >= 100) {SinalVende_1 = 99.9;}
         if (SinalCompra <= 0) {SinalCompra = 0.1;}
         if (SinalCompra >= 100) {SinalCompra = 99.9;}
         if (SinalVende <= 0) {SinalVende = 0.1;}
         if (SinalVende >= 100) {SinalVende = 99.9;}
         

         double Sinal = (((SinalCompra + SinalCompra_1 + SinalCompra_2)/3)-((SinalVende + SinalVende_1 + SinalVende_2)/3));





//+------------------------------------------------------------------+
//| Pivot, Support and Resistance                                    |
//+------------------------------------------------------------------+

//----

       P  =	(iHigh(NULL,PERIOD_D1,1) + iLow(NULL,PERIOD_D1,1) + iClose(NULL,PERIOD_D1,1)) / 3;

       R1 =	2*P - iLow(NULL,PERIOD_D1,1);
       R0_1 = P + ((R1-P)*Indice_RS_0_1);
       R0_1_1 = R1 - ((R2-R1)*Indice_RS_0_1_1);
       R2 =	P + (iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1));
       R3 =	P + 2*(iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1));

       S1 =	2*P - iHigh(NULL,PERIOD_D1,1);
       S0_1 = P - ((P-S1)*Indice_RS_0_1);
       S0_1_1 = S1 + ((S1-S2)*Indice_RS_0_1_1);       
       S2 =	P - (iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1));
       S3 =	P - 2*(iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1));

//----

   ObjectDelete("PivotText");
   ObjectDelete("S1Text");
      ObjectDelete("S0_1Text");
   ObjectDelete("R1Text");
      ObjectDelete("R0_1Text");
   ObjectDelete("S2Text");
      ObjectDelete("S0_1_1Text");
   ObjectDelete("R2Text");
      ObjectDelete("R0_1_1Text");
   ObjectDelete("S3Text");
   ObjectDelete("R3Text");   
   ObjectDelete("PivotDJ");
   ObjectDelete("Sup1");
      ObjectDelete("Sup0_1");
      ObjectDelete("Sup0_1_1");       
   ObjectDelete("Res1");
      ObjectDelete("Res0_1");
      ObjectDelete("ReS0_1_1");    
   ObjectDelete("Sup2");  
   ObjectDelete("Res2");  
   ObjectDelete("Sup3");
   ObjectDelete("Res3"); 
//----      
   ObjectCreate("PivotText", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("PivotText", "Pivot "+P, fontsize, "Arial", colorPivot);
   ObjectCreate("S1Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("S1Text", "S1 "+S1, fontsize, "Arial", colorSup1);
      ObjectCreate("S0_1Text", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("S0_1Text", "S0_1 "+S0_1, fontsize, "Arial", colorSup0_1);
      ObjectCreate("S0_1_1Text", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("S0_1_1Text", "S0_1_1 "+S0_1_1, fontsize, "Arial", colorSup0_1_1);
   ObjectCreate("R1Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("R1Text", "R1 "+R1, fontsize, "Arial", colorRes1);
      ObjectCreate("R0_1Text", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("R0_1Text", "R0_1 "+R0_1, fontsize, "Arial", colorRes0_1);
      ObjectCreate("R0_1_1Text", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("R0_1_1Text", "R0_1_1 "+R0_1_1, fontsize, "Arial", colorRes0_1_1);
   ObjectCreate("S2Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("S2Text", "S2 "+S2, fontsize, "Arial", colorSup2);
   ObjectCreate("R2Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("R2Text", "R2 "+R2, fontsize, "Arial", colorRes2);
   ObjectCreate("S3Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("S3Text", "S3 "+S3, fontsize, "Arial", colorSup3);
   ObjectCreate("R3Text", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("R3Text", "R3 "+R3, fontsize, "Arial", colorRes3);

//----

   TodaysSeconds = TimeSeconds(TimeCurrent()) + TimeMinute(TimeCurrent())*60 + TimeHour(TimeCurrent())*60*60;

//----
   ObjectCreate("PivotDJ", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, P, TimeCurrent(), P);
   ObjectSet("PivotDJ", OBJPROP_COLOR, colorPivot);
   ObjectSet("PivotDJ", OBJPROP_WIDTH, 2);
   ObjectSet("PivotDJ", OBJPROP_STYLE, STYLE_SOLID);
//----
   ObjectCreate("Sup1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, S1, TimeCurrent(), S1);
   ObjectSet("Sup1", OBJPROP_COLOR, colorSup1);
   ObjectSet("Sup1", OBJPROP_WIDTH, 0);
   ObjectSet("Sup1", OBJPROP_STYLE, STYLE_SOLID);
//----
      ObjectCreate("Sup0_1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, S0_1, TimeCurrent(), S0_1);
      ObjectSet("Sup0_1", OBJPROP_COLOR, colorSup0_1);
      ObjectSet("Sup0_1", OBJPROP_WIDTH, 0);
      ObjectSet("Sup0_1", OBJPROP_STYLE, STYLE_DASH);
//----
      ObjectCreate("Sup0_1_1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, S0_1_1, TimeCurrent(), S0_1_1);
      ObjectSet("Sup0_1_1", OBJPROP_COLOR, colorSup0_1_1);
      ObjectSet("Sup0_1_1", OBJPROP_WIDTH, 0);
      ObjectSet("Sup0_1_1", OBJPROP_STYLE, STYLE_DASH);
//----   
   ObjectCreate("Sup2", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, S2, TimeCurrent(), S2);
   ObjectSet("Sup2", OBJPROP_COLOR, colorSup2);
   ObjectSet("Sup2", OBJPROP_WIDTH, 0);
   ObjectSet("Sup2", OBJPROP_STYLE, STYLE_SOLID);
//----   
   ObjectCreate("Sup3", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, S3, TimeCurrent(), S3);
   ObjectSet("Sup3", OBJPROP_COLOR, colorSup3);
   ObjectSet("Sup3", OBJPROP_WIDTH, 0);
   ObjectSet("Sup3", OBJPROP_STYLE, STYLE_SOLID);
//----   
   ObjectCreate("Res1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, R1, TimeCurrent(), R1);
   ObjectSet("Res1", OBJPROP_COLOR, colorRes1);
   ObjectSet("Res1", OBJPROP_WIDTH, 0);
   ObjectSet("Res1", OBJPROP_STYLE, STYLE_SOLID);
//----   
      ObjectCreate("Res0_1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, R0_1, TimeCurrent(), R0_1);
      ObjectSet("Res0_1", OBJPROP_COLOR, colorRes0_1);
      ObjectSet("Res0_1", OBJPROP_WIDTH, 0);
      ObjectSet("Res0_1", OBJPROP_STYLE, STYLE_DASH);
//----   
      ObjectCreate("Res0_1_1", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, R0_1_1, TimeCurrent(), R0_1_1);
      ObjectSet("Res0_1_1", OBJPROP_COLOR, colorRes0_1_1);
      ObjectSet("Res0_1_1", OBJPROP_WIDTH, 0);
      ObjectSet("Res0_1_1", OBJPROP_STYLE, STYLE_DASH);
//----  
   ObjectCreate("Res2", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, R2, TimeCurrent(), R2);
   ObjectSet("Res2", OBJPROP_COLOR, colorRes2);
   ObjectSet("Res2", OBJPROP_WIDTH, 0);
   ObjectSet("Res2", OBJPROP_STYLE, STYLE_SOLID);
//---- 
   ObjectCreate("Res3", OBJ_TREND, 0, TimeCurrent()-TodaysSeconds, R3, TimeCurrent(), R3);
   ObjectSet("Res3", OBJPROP_COLOR, colorRes3);
   ObjectSet("Res3", OBJPROP_WIDTH, 0);
   ObjectSet("Res3", OBJPROP_STYLE, STYLE_SOLID);
//----
   

//----
   ObjectMove("PivotText", 0, TimeCurrent(), P);
   ObjectMove("S1Text", 0, TimeCurrent(), S1);
      ObjectMove("S0_1Text", 0, TimeCurrent(), S0_1);
      ObjectMove("S0_1_1Text", 0, TimeCurrent(), S0_1_1);      
   ObjectMove("R1Text", 0, TimeCurrent(), R1);
      ObjectMove("R0_1Text", 0, TimeCurrent(), R0_1);
      ObjectMove("R0_1_1Text", 0, TimeCurrent(), R0_1_1);      
   ObjectMove("S2Text", 0, TimeCurrent(), S2);
   ObjectMove("R2Text", 0, TimeCurrent(), R2);
   ObjectMove("S3Text", 0, TimeCurrent(), S3);
   ObjectMove("R3Text", 0, TimeCurrent(), R3);
//----


      if ((Ask > R0_1 && Bid > R0_1)||(Bid < S0_1 && Ask < S0_1)) Tradable = "Inside";
      else Tradable = "Outside";



         // Tradable Hours
         TradableHours = "No";
         if (Hour()*60 + Minute() > Periods*IncrementTrend && Hour()*60 + Minute() < 1437) TradableHours = "Yes";

/*
         //Close trades at the end of Day if they have no profit
         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (Hour() == 23 && Minute() >= 57 && OrderType() == OP_SELL && OrderProfit() < 0) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (Hour() == 23 && Minute() >= 57 && OrderType() == OP_BUY && OrderProfit() < 0) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }
        
         
         //Close trades at the end of Week
         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (DayOfWeek() == 5 && Hour() == 23 && Minute() >= 57 && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (DayOfWeek() == 5 && Hour() == 23 && Minute() >= 57 && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }
*/ 



         //Average Open Lots
         
         AverageOpenLots = 0;
         for (i = 0; i < OrdersTotal(); i++) {
            OrderSelect(i, SELECT_BY_POS);
            AverageOpenLots = AverageOpenLots + OrderLots();
            }
            
            if (OrdersTotal() > 0) AverageOpenLots = AverageOpenLots / OrdersTotal();

         
         
         
         //Tomada de Deciso
         


         BuyTriger = 0;
         SellTriger = 0;
         
         
         //Buy Signal - Ascending StdDev
         if (Sinal >= SinalDecisao && ((Bid < S0_1 && Ask < S0_1)||(Ask > R0_1 && Bid > R0_1)) && TradableHours == "Yes") {
               //  
               BuyTriger = 0;       //INVERSO
               SellTriger = 1;       //INVERSO



                     //INVERSE AGAIN...
   
                        if (BuyTriger == 0 && SellTriger == 1 && PercentTrend >= TrendLimit && ADX_Plus_Prev_Trend < ADX_Plus_Trend && StdDev_0_Trend > StdDev_1_Trend) {
                              BuyTriger = 1;
                              SellTriger = 0;
                           }
                     
                     
               
         //Gesto de Lots - BUY
         Lots = MarketInfo(Symbol(),MODE_MINLOT);
         while (AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)>AccountFreeMargin()*(100-(PercentToRisk/Instruments))/100)     //AccountBalance ou AccountFreeMargin ???????
               {Lots = Lots + MarketInfo(Symbol(),MODE_LOTSTEP);}
               if ((MaxOpenTPair*Instruments) - OrdersTotal() >= 1) Lots = Lots / ((MaxOpenTPair*Instruments) - OrdersTotal());
               if (Lots > 2*AverageOpenLots && AverageOpenLots > 0) Lots = (Lots + AverageOpenLots)/2;
               if (Limitations == "Yes") Lots = LimitMaxLot;
               if (Lots > MarketInfo(Symbol(),MODE_MAXLOT)) Lots = MarketInfo(Symbol(),MODE_MAXLOT);
               if (Lots < MarketInfo(Symbol(),MODE_MINLOT)) Lots = MarketInfo(Symbol(),MODE_MINLOT);
               Lots = NormalizeDouble(Lots,1);
               
               
         }


         
         //Sell Signal - Ascending StdDev
         if (Sinal <= SinalDecisao*(-1) && ((Bid < S0_1 && Ask < S0_1)||(Ask > R0_1 && Bid > R0_1)) && TradableHours == "Yes") {
               // 
               SellTriger = 0;       //INVERSO
               BuyTriger = 1;       //INVERSO


                     //INVERSE AGAIN...
   
                        if (BuyTriger == 1 && SellTriger == 0 && PercentTrend <= -1*TrendLimit && ADX_Minus_Prev_Trend < ADX_Minus_Trend && StdDev_0_Trend > StdDev_1_Trend ) {
                              BuyTriger = 0;
                              SellTriger = 1;
                           }
                           
                 
               
         //Gesto de Lots - SELL
         Lots = MarketInfo(Symbol(),MODE_MINLOT);
         while (AccountFreeMarginCheck(Symbol(),OP_SELL,Lots)>AccountFreeMargin()*(100-(PercentToRisk/Instruments))/100)     //AccountBalance ou AccountFreeMargin ???????
               {Lots = Lots + MarketInfo(Symbol(),MODE_LOTSTEP);}
               if ((MaxOpenTPair*Instruments) - OrdersTotal() >= 1) Lots = Lots / ((MaxOpenTPair*Instruments) - OrdersTotal());
               if (Lots > 2*AverageOpenLots && AverageOpenLots > 0) Lots = (Lots + AverageOpenLots)/2;
               if (Limitations == "Yes") Lots = LimitMaxLot;
               if (Lots > MarketInfo(Symbol(),MODE_MAXLOT)) Lots = MarketInfo(Symbol(),MODE_MAXLOT);
               if (Lots < MarketInfo(Symbol(),MODE_MINLOT)) Lots = MarketInfo(Symbol(),MODE_MINLOT);
               Lots = NormalizeDouble(Lots,1);
               
               
         }


         Trade = "HOLD";


//SETAS...



if (BuyTriger == 1) {
         ObjectCreate("ArrowUP"+TimeCurrent(), OBJ_ARROW, 0, TimeCurrent(),Open[0]);
         ObjectSet("ArrowUP"+TimeCurrent(), OBJPROP_ARROWCODE, 217);
         ObjectSet("ArrowUP"+TimeCurrent(), OBJPROP_COLOR, Blue); 
            ObjectCreate("SinalUP"+Year()+Month()+Day()+Hour()+Minute(), OBJ_TEXT, 0, TimeCurrent(),Close[0]);
            ObjectSetText("SinalUP"+Year()+Month()+Day()+Hour()+Minute(), DoubleToStr(PercentTrend,0), 10, "Impact", Yellow);
         Trade = "BUY";
         }

if (SellTriger == 1) {
         ObjectCreate("ArrowDOWN"+TimeCurrent(), OBJ_ARROW, 0, TimeCurrent(),Open[0]);
         ObjectSet("ArrowDOWN"+TimeCurrent(), OBJPROP_ARROWCODE, 218);
         ObjectSet("ArrowDOWN"+TimeCurrent(), OBJPROP_COLOR, Red);
            ObjectCreate("SinalDN"+Year()+Month()+Day()+Hour()+Minute(), OBJ_TEXT, 0, TimeCurrent(),Close[0]);
            ObjectSetText("SinalDN"+Year()+Month()+Day()+Hour()+Minute(), DoubleToStr(PercentTrend,0), 10, "Impact", Yellow);
         Trade = "SELL";
         }
  



        



         Comment ("UP Avg.: ", SinalCompra_2," + ", SinalCompra_1," + ", SinalCompra," / 3 = ", NormalizeDouble(((SinalCompra_2+SinalCompra_1+SinalCompra)/3),0), "%\n",
                  "DN Avg.: ", SinalVende_2," + ", SinalVende_1," + ",SinalVende," / 3 = ", NormalizeDouble(((SinalVende_2+SinalVende_1+SinalVende)/3),0), "%\n",
                  "Sinal: ", Sinal, "\n",
                  "Open Limit: ",SinalDecisao," %", "\n",
                  "ADX Trend: ", (ADX_Trend), "\n",
                  "Std. Dev.: ", (Std_Dev_T), "\n",
                  "Tradable Area: ", (Tradable), "\n",
                  "Tradable Hours: ", (TradableHours), "\n",
                  "Percent Trend: ", (PercentTrend), " %", "\n",
                  "--------------------------", "\n",
                  "TRADE: ", (Trade), "\n");




/*
         //Mover Stop Loss, passado "Hours2Analize"...
         
         
         
         //Mover stop loss - BUY
      for (x = 0; x <= OrdersTotal()+1; x++) {
      
         OrderSelect(x, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_BUY)
            {
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(TimeCurrent()-OrderOpenTime()>(1.5*Hours2Analize*60*60) && Bid > OrderOpenPrice() && (Bid - (SymPoints * TrailingStop)) > OrderStopLoss()) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - (SymPoints * TrailingStop), OrderTakeProfit()+2*(Bid - (SymPoints * TrailingStop)), 0, Yellow);
                     if (!EachTickMode) BarCount = Bars;
                     }
                  }
               }
            }
      
      
      //Mover stop loss - SELL
      for (y = 0; y <= OrdersTotal()+1; y++) {
      
         OrderSelect(y, SELECT_BY_POS);
         if (OrderSymbol() == Sym && OrderType() == OP_SELL)
            {
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(TimeCurrent()-OrderOpenTime()>(1.5*Hours2Analize*60*60) && Ask < OrderOpenPrice( )&& (Ask + (SymPoints * TrailingStop)) < OrderStopLoss()) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + (SymPoints * TrailingStop), OrderTakeProfit()+2*(Ask + (SymPoints * TrailingStop)), 0, Yellow);
                     if (!EachTickMode) BarCount = Bars;
                     }
                  }
               }
            }
  

*/



         //Reduzir o TakeProfit, depois de Hours2Analize
         
         
         int TimeDif;
         
      //Reduzir TP - BUY
         for (i = 0; i < OrdersTotal(); i++) {
         OrderSelect(i, SELECT_BY_POS);
         TimeDif = TimeCurrent()-OrderOpenTime();
         if (OrderSymbol() == Sym && OrderType() == OP_BUY && TimeCurrent()-OrderOpenTime()>(Hours2Analize*60*60) && TimeDif%300 == 300 && ((OrderTakeProfit()-OrderOpenPrice())/SymPoints) > ProfitTarget/2) // Reduz APROX. um ponto ao TP, a cada 5 minutos (300 segundos)
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderTakeProfit()-SymPoints, 0, Yellow);      
            }           
            
            //Comment (TimeDif," ",TimeDif%300, " ", (OrderTakeProfit()-OrderOpenPrice())/SymPoints);



      //Reduzir TP - SELL
         for (i = 0; i < OrdersTotal(); i++) {
         OrderSelect(i, SELECT_BY_POS);
         TimeDif = TimeCurrent()-OrderOpenTime();
         if (OrderSymbol() == Sym && OrderType() == OP_SELL && TimeCurrent()-OrderOpenTime()>(Hours2Analize*60*60) && TimeDif%300 == 300 && ((OrderOpenPrice()-OrderTakeProfit())/SymPoints) > ProfitTarget/2) // Reduz APROX. um ponto ao TP, a cada 5 minutos (300 segundos)
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderTakeProfit()+SymPoints, 0, Yellow);       
            }




         //Close orders with profit, that are open for more than "Hours2Analize"...
         
         
         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }


         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>0.80*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(2*Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>0.80*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(2*Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }
 
         
         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>0.60*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(3*Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>0.60*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(3*Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }         


         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>0.40*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(4*Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>0.40*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(4*Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         } 


         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>0.20*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(5*Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>0.20*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(5*Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         } 


         for (j=0; j<=OrdersTotal(); j++) {
            OrderSelect(j, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderProfit()>0.05*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(6*Hours2Analize*60*60) && OrderType() == OP_SELL) {
                  OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
                  }
               if (OrderSymbol() == Sym && OrderProfit()>0.05*AccountBalance()*PercentToRisk/100 && TimeCurrent()-OrderOpenTime()>(6*Hours2Analize*60*60) && OrderType() == OP_BUY) {
                  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
                  }
         }
         
         
         
         
         
         
         //---- Decision
         

         //Close SELL orders to avoid hedging
         if( BuyTriger == 1 && (Hedge == false || (Ask > R0_1_1 && Bid > R0_1_1) || Sinal > Sinalparasair)) { 
            for (int sell = 0; sell <= OrdersTotal()+1; sell++) {
               OrderSelect(sell, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderType() == OP_SELL)
                  {OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Blue);}
                  }
            } 


         
         
         //Place BUY   
                 OpenTPair = 0;
                 for (j=0; j<=OrdersTotal(); j++){
                     OrderSelect(j, SELECT_BY_POS);
                     if (OrderSymbol() == Sym) OpenTPair++;
                     }
              if(BuyTriger == 1 && OpenTPair < MaxOpenTPair)
              {
              Print ("BUY: Account Free Margin Check: ",AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)," Account Free Margin: ",AccountFreeMargin()," Sinal de Compra: ", SinalCompra);
                     
              EnterLong(Sym, Lots, "");

              BuyTriger = 0;
              if (Limitations == "Yes") ProfitTarget = 10;
              }
              
              
              
              
 
         
         //Close BUY orders to avoid hedging
         if(SellTriger == 1 && (Hedge == false || (Ask < S0_1_1 && Bid < S0_1_1) || Sinal < Sinalparasair*(-1))) { 
            for (int buy = 0; buy <= OrdersTotal()+1; buy++) {
               OrderSelect(buy, SELECT_BY_POS);
               if (OrderSymbol() == Sym && OrderType() == OP_BUY)
                  {OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);}
                  }
            }   
  
      

             
             
         //Place SELL
               OpenTPair = 0;
               for (j=0; j<=OrdersTotal(); j++){
                     OrderSelect(j, SELECT_BY_POS);
                     if (OrderSymbol() == Sym) OpenTPair++;
                     }   
              if(SellTriger == 1 && OpenTPair < MaxOpenTPair)
              //
              {
              Print ("SELL: Account Free Margin Check: ",AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)," Account Free Margin: ",AccountFreeMargin()," Sinal de Venda: ", SinalVende);
              
              EnterShrt(Sym, Lots, "");              
              
              SellTriger = 0;
              if (Limitations == "Yes") ProfitTarget = 10;
              }
          
     
      //----
   
   //----
   
  
   
   
   
   return(0); 
}

//+------------------------------------------------------------------+
//| Expert Custom Functions                                          |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Calculate Stop Long                                              |
//+------------------------------------------------------------------+
double StopLong(double price,double stop,double point,double SymDgts )
{
 if(stop==0) { return(0); }
 else        { return(NormalizeDouble( price-(stop*point),SymDgts)); }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Stop Short                                             |
//+------------------------------------------------------------------+
double StopShrt(double price,double stop,double point,double SymDgts )
{
 if(stop==0) { return(0); }
 else        { return(NormalizeDouble( price+(stop*point),SymDgts)); }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeLong(double price,double take,double point,double SymDgts )
{
 if(take==0) {  return(0);}
 else        {  return(NormalizeDouble( price+(take*point),SymDgts));}
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeShrt(double price,double take,double point,double SymDgts )
{
 if(take==0) {  return(0);}
 else        {  return(NormalizeDouble( price-(take*point),SymDgts));}
}
//+------------------------------------------------------------------+




//+------------------------------------------------------------------+
//| Place Long Order                                                 |
//+------------------------------------------------------------------+
int EnterLong( string FinalSymbol, double FinalLots, string EA_Comment )
{
   int Ticket = -1; int err = 0; bool OrderLoop = False; int TryCount = 0;
                     
   while( !OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 15 ); }
                           
      RefreshRates();
      double SymAsk = NormalizeDouble( MarketInfo( FinalSymbol, MODE_ASK ), SymDigits );    
      double SymBid = NormalizeDouble( MarketInfo( FinalSymbol, MODE_BID ), SymDigits );
      
      if (UseStopLoss) StopLossLevel = StopLong(SymBid,StopLoss, SymPoints,SymDigits); else StopLossLevel = 0.0;
      if (UseTakeProfit) TakeProfitLevel = TakeLong(SymAsk,ProfitTarget,SymPoints,SymDigits); else TakeProfitLevel = 0.0;
                               
      Ticket = OrderSend( FinalSymbol, OP_BUY, FinalLots, Ask, Slippage, 0.0, 0.0, EA_Comment, MagicNumber, 0, Green ); 

   Print ( FinalSymbol," Lots: ", FinalLots," Ask: ", Ask," Slipage: ", Slippage," Points: ",Point," SymPoints: ",NormalizeDouble(SymPoints,SymDigits)," SL: ", StopLossLevel," TP: ", TakeProfitLevel);
                           
      int Err=GetLastError();
      
      switch (Err) 
      {
           //---- Success
           case               ERR_NO_ERROR: OrderLoop = true; 
                                            if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                            { OrderModify( Ticket, OrderOpenPrice(), StopLong(SymBid,StopLoss, SymPoints,SymDigits), TakeLong(SymAsk,ProfitTarget,SymPoints,SymDigits), 0, CLR_NONE ); }
                                            break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = true; Print( "Invalid Stops"    ); break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = true; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = true; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = true; Print( "Unknown Error - " + Err ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = true; }
   }
   //----               
   return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Place Shrt Order                                                 |
//+------------------------------------------------------------------+
int EnterShrt( string FinalSymbol, double FinalLots, string EA_Comment )
{
   int Ticket = -1; int err = 0; bool OrderLoop = False; int TryCount = 0;
                     
   while( !OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 15 ); }
                           
      RefreshRates();
      double SymAsk = NormalizeDouble( MarketInfo( FinalSymbol, MODE_ASK ), SymDigits );    
      double SymBid = NormalizeDouble( MarketInfo( FinalSymbol, MODE_BID ), SymDigits );
      
      if (UseStopLoss) StopLossLevel = StopShrt(SymAsk,StopLoss, SymPoints,SymDigits); else StopLossLevel = 0.0;
      if (UseTakeProfit) TakeProfitLevel = TakeShrt(SymBid,ProfitTarget, SymPoints,SymDigits); else TakeProfitLevel = 0.0;

                               
      Ticket = OrderSend( FinalSymbol, OP_SELL, FinalLots, Bid, Slippage, 0.0, 0.0, EA_Comment, MagicNumber, 0, Red ); 

   Print ( FinalSymbol," Lots: ", FinalLots," Ask: ", Bid," Slipage: ", Slippage," Points: ",Point," SymPoints: ",NormalizeDouble(SymPoints,SymDigits)," SL: ", StopLossLevel," TP: ", TakeProfitLevel);
                           
      int Err=GetLastError();
      
      switch (Err) 
      {
           //---- Success
                 case               ERR_NO_ERROR: OrderLoop = true;
                                                  if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                                  { OrderModify( Ticket, OrderOpenPrice(), StopShrt(SymAsk,StopLoss, SymPoints,SymDigits), TakeShrt(SymBid,ProfitTarget, SymPoints,SymDigits), 0, CLR_NONE ); }
                                                  break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = true; Print( "Invalid Stops"    ); break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = true; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = true; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = true; Print( "Unknown Error - " + Err ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = true; }
   }
   //----               
   return(Ticket);
}
//+------------------------------------------------------------------+